#bind all <ButtonPress>          {puts "bpress %b  		%W -- (%X,%Y)"}
#bind all <ButtonRelease>        {puts "brelea %b    	%W -- (%X,%Y)"}
#bind all <KeyPress>  	        {puts "kpress %K    	%W -- (%X,%Y)"}
#bind all <KeyRelease>   	    {puts "krelea %K    	%W -- (%X,%Y)"}

#bind all <Motion>				{lappend __record__ [list $__timer__ %W <Motion> %X %Y]}
#bind all <ButtonPress>			{lappend __record__ [list $__timer__ %W <ButtonPress-%b> %X %Y]}
#bind all <ButtonRelease>		{lappend __record__ [list $__timer__ %W <ButtonRelease-%b> %X %Y]}
#bind all <KeyPress>			{lappend __record__ [list $__timer__ %W <KeyPress-%K> %X %Y]}
#bind all <KeyRelease> 			{lappend __record__ [list $__timer__ %W <KeyRelease-%K> %X %Y]}

#-----------------------------------------------------

destroy .b
entry .b -text toto
pack .b -padx 10 -pady 10

destroy .t
toplevel .t
bind .t <Enter> ".t configure -bg red"
bind .t <Leave> ".t configure -bg lightgray"
button .t.b -text top--toto -command "puts top--toto"
pack .t.b -padx 10 -pady 10


#-----------------------------------------------------

#event generate .b <Motion> -warp true -x 10 -y 10
#event generate .b <ButtonPress-1> -warp true -x 10 -y 10
#after 100 {event generate .b <ButtonRelease-1> -warp true -x 10 -y 10}

proc record {} {
global __timer__ __oldX__ __oldY__ __record__ __save__

	set __timer__ 0
	set __oldX__ -1
	set __oldY__ -1
	after 10 updateTimer
	set __record__ {}
	proc updateTimer {} {
	global __timer__ __oldX__ __oldY__ __record__

		set X [winfo pointerx .]
		set Y [winfo pointery .]
		if {[winfo containing $X $Y] == {}} {
			if {$__oldX__ != $X || $__oldY__ != $Y} {
				lappend __record__ [list $__timer__ {} <Motion> $X $Y]
				set __oldX__ $X
				set __oldY__ $Y
			}
		}
		incr __timer__ 10
		after 10 updateTimer
		# test
		if ![expr $__timer__ % 500] {
			lappend __record__ [list $__timer__ "action $__timer__"]
		}
	}

	set __save__(motion) [bind all <Motion>]
	set __save__(bp) [bind all <ButtonPress>]
	set __save__(br) [bind all <ButtonRelease>]
	set __save__(kp) [bind all <KeyPress>]
	set __save__(kr) [bind all <KeyRelease>]

	bind all <Motion>		{+lappend __record__ [list $__timer__ %W <Motion> %x %y]}
	bind all <ButtonPress>	{+lappend __record__ [list $__timer__ %W <ButtonPress-%b> %x %y]}
	bind all <ButtonRelease> {+lappend __record__ [list $__timer__ %W <ButtonRelease-%b> %x %y]}
	bind all <KeyPress> 	{+lappend __record__ [list $__timer__ %W <KeyPress-%K> %x %y]}
	bind all <KeyRelease>	{+lappend __record__ [list $__timer__ %W <KeyRelease-%K> %x %y]}
}

proc stop {} {
global __save__

	proc updateTimer {} {}

	bind all <Motion>		$__save__(motion)
	bind all <ButtonPress>	$__save__(bp)
	bind all <ButtonRelease> $__save__(br)
	bind all <KeyPress> 	$__save__(kp)
	bind all <KeyRelease>	$__save__(kr)
}

proc play {{speed 1}} {
global __record__ __oldtimer__ __speed__ __max__

	set __max__ [expr [llength $__record__]-1]
	set __speed__ $speed
	set __oldtimer__ [lindex [lindex $__record__ 0] 0]
	after idle "replay 0"
}

proc replay {i} {
global __record__ __oldtimer__ __speed__ __max__

	set data [lindex $__record__ $i]
	if {[llength $data] == 5} {
		event generate [lindex $data 1] [lindex $data 2] -warp true \
				-x [lindex $data 3] -y [lindex $data 4]
	} else {
		puts [lindex $data 1]
	}

	if {$i < $__max__} {
		after [expr int(([lindex $data 0]-$__oldtimer__)/$__speed__)] "replay [incr i]"
		set __oldtimer__ [lindex $data 0]
	}
}
