
/*  A Bison parser, made from parser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tSTRING	257
#define	tNAME	258
#define	tDESCRIPTION	259
#define	tCOPYRIGHT	260
#define	tTEXT	261
#define	tFILENAME	262
#define	tDANCERS	263
#define	tINIT	264
#define	tKEY	265
#define	tROUTINE	266
#define	tMOVIE	267
#define	tNOTES	268
#define	tMAP	269
#define	tWITH	270
#define	tREJECT	271
#define	tCOLOR	272
#define	tINCLUDENOTES	273
#define	tBEZIER	274
#define	tHANDLES	275
#define	tHANDLELEFT	276
#define	tHANDLERIGHT	277
#define	tLINEAR	278
#define	tEYE	279
#define	tCENTER	280
#define	tMAN	281
#define	tWOMAN	282
#define	tINTEGER	283
#define	tBEATS	284
#define	tRHYTHM	285
#define	tBPM	286
#define	tTRACKNAME	287
#define	tJOINTNAME	288
#define	tDOUBLE	289

#line 1 "parser.y"

#include "togl.h"

#include "list.h"
#include "routine.h"
#include "track.h"
#include "movie.h"
#include "body.h"	// for track enum

#ifdef WIN32
#include <malloc.h>
#define alloca _alloca
#else
#include <stdlib.h>
#endif



#define DOERROR(msg) {yyerror(msg); YYERROR;}

// Comes from the parser
extern int yylineno;
extern FILE *yyin;
const char *yyfilename;
extern int yylex(void);
extern Tcl_Interp *currentInterp;

// Local prototypes
void yyerror(const char *msg);

// Local vars
class Routine *routine;
int parserMode;

static class Key *key;
static class Figure *figure;
static class Movie *movie;
static class Modif modif;
static class List<Bezier3D> *path;
static class List<Chunk> *chunks;
static class List<Modif> *modifs;
static class List<Note> *notes;
static double doublelist[10];
static double v1, v2;

#line 49 "parser.y"
typedef union {
	int integer;
	double numeric;
	char *string;
	struct {int start, end;} time;
	struct {int time; double value;} point;
	struct {int time; double x,y,z;} point3D;
	struct {int start, end; char *string;} annotation;
	struct {double *v;} doublelist;
	struct {char *name, *type; int sex;} dancerinfo;
	struct {void *path;} path;		// class List<Bezier3D> *path;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		233
#define	YYFLAG		-32768
#define	YYNTBASE	49

#define YYTRANSLATE(x) ((unsigned)(x) <= 289 ? yytranslate[x] : 90)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    39,
    40,     2,    46,    41,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    44,     2,    47,
    36,    48,     2,    42,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    43,     2,    45,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    37,     2,    38,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     4,     8,     9,    14,    18,    22,    26,    30,
    34,    38,    39,    47,    48,    57,    58,    70,    71,    77,
    91,    95,    97,    99,   105,   111,   119,   121,   123,   124,
   131,   136,   138,   139,   142,   143,   147,   149,   153,   154,
   157,   158,   159,   164,   166,   170,   174,   176,   180,   191,
   194,   198,   199,   201,   203,   207,   209,   211,   215,   223,
   224,   226,   227,   232,   233,   237,   239,   240,   243,   244,
   249,   254,   258,   260,   263,   265,   266,   272,   274,   278,
   280,   284,   285,   289,   291,   293,   300,   307,   318,   319,
   323,   326,   327,   328,   331,   337,   341,   349,   350
};

static const short yyrhs[] = {    49,
    50,     0,     0,    30,    36,    29,     0,     0,     9,    36,
    51,    56,     0,    31,    36,    29,     0,    32,    36,    29,
     0,     4,    36,     3,     0,     5,    36,     3,     0,     6,
    36,     3,     0,     7,    36,     3,     0,     0,    10,    62,
    36,    37,    52,    60,    38,     0,     0,    11,    62,    59,
    36,    37,    53,    63,    38,     0,     0,    12,    54,    39,
    72,    40,    59,    36,    37,    73,    75,    38,     0,     0,
    14,    62,    36,    55,    70,     0,    13,    39,     3,    40,
    36,    37,    26,    36,    85,    25,    36,    85,    38,     0,
    56,    41,    57,     0,    57,     0,     3,     0,    37,     3,
    41,     3,    38,     0,    37,    58,    41,     3,    38,     0,
    37,    58,    41,     3,    41,     3,    38,     0,    27,     0,
    28,     0,     0,    42,    43,    29,    44,    29,    45,     0,
    42,    43,     1,    45,     0,    42,     0,     0,    60,    61,
     0,     0,    33,    36,    69,     0,     8,     0,    39,    29,
    40,     0,     0,    63,    64,     0,     0,     0,    33,    36,
    65,    66,     0,     8,     0,    68,    24,    66,     0,    68,
    67,    66,     0,    68,     0,    68,    41,    66,     0,    20,
    39,    69,    41,    69,    41,    69,    41,    69,    40,     0,
    20,     1,     0,    69,    42,    29,     0,     0,    35,     0,
    29,     0,    71,    41,    70,     0,    71,     0,     1,     0,
     3,    42,    29,     0,     3,    42,    43,    29,    44,    29,
    45,     0,     0,     8,     0,     0,    15,    39,    74,    40,
     0,     0,    74,    41,    29,     0,    29,     0,     0,    75,
    76,     0,     0,    16,    37,    77,    38,     0,    17,    37,
    84,    38,     0,    18,    36,     3,     0,    19,     0,    77,
    78,     0,    78,     0,     0,    33,    62,    36,    79,    80,
     0,     8,     0,    80,    41,    81,     0,    81,     0,    82,
    42,    29,     0,     0,    82,    46,    83,     0,    83,     0,
    69,     0,    22,    39,    69,    41,    69,    40,     0,    23,
    39,    69,    41,    69,    40,     0,    21,    39,    69,    41,
    69,    41,    69,    41,    69,    40,     0,     0,    84,    34,
    62,     0,    34,    62,     0,     0,     0,    86,    87,     0,
    88,    42,    29,    89,    87,     0,    88,    42,    29,     0,
    47,    69,    41,    69,    41,    69,    48,     0,     0,    20,
    39,    88,    41,    88,    40,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    87,    88,    91,    93,    96,    96,    98,   100,   102,   104,
   106,   108,   108,   116,   116,   130,   131,   141,   142,   159,
   172,   176,   181,   182,   183,   184,   187,   188,   189,   194,
   196,   199,   201,   206,   207,   210,   223,   228,   229,   232,
   233,   236,   237,   250,   254,   263,   270,   271,   274,   277,
   280,   281,   284,   285,   290,   300,   310,   313,   321,   330,
   335,   341,   343,   344,   347,   354,   360,   363,   364,   367,
   368,   369,   380,   384,   385,   388,   389,   400,   403,   404,
   407,   413,   416,   417,   420,   424,   429,   434,   442,   447,
   456,   465,   469,   470,   482,   495,   501,   502,   504
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tSTRING",
"tNAME","tDESCRIPTION","tCOPYRIGHT","tTEXT","tFILENAME","tDANCERS","tINIT","tKEY",
"tROUTINE","tMOVIE","tNOTES","tMAP","tWITH","tREJECT","tCOLOR","tINCLUDENOTES",
"tBEZIER","tHANDLES","tHANDLELEFT","tHANDLERIGHT","tLINEAR","tEYE","tCENTER",
"tMAN","tWOMAN","tINTEGER","tBEATS","tRHYTHM","tBPM","tTRACKNAME","tJOINTNAME",
"tDOUBLE","'='","'{'","'}'","'('","')'","','","'@'","'['","':'","']'","'+'",
"'<'","'>'","input","statement","@1","@2","@3","@4","@5","dancers","dancerInfo",
"sex","time","inits","init_entry","dancer","keys","key_entry","@6","chunks",
"bezier","point","number","notes","annotation","name","map","map_args","options",
"option","modifs","modif_entry","@7","modif","action","settings","setting","joints",
"path","@8","path_entries","point3D","bezier3D", NULL
};
#endif

static const short yyr1[] = {     0,
    49,    49,    50,    51,    50,    50,    50,    50,    50,    50,
    50,    52,    50,    53,    50,    54,    50,    55,    50,    50,
    56,    56,    57,    57,    57,    57,    58,    58,    58,    59,
    59,    59,    59,    60,    60,    61,    61,    62,    62,    63,
    63,    65,    64,    64,    66,    66,    66,    66,    67,    67,
    68,    68,    69,    69,    70,    70,    70,    71,    71,    71,
    72,    72,    73,    73,    74,    74,    74,    75,    75,    76,
    76,    76,    76,    77,    77,    79,    78,    78,    80,    80,
    81,    81,    82,    82,    83,    83,    83,    83,    83,    84,
    84,    84,    86,    85,    87,    87,    88,    88,    89
};

static const short yyr2[] = {     0,
     2,     0,     3,     0,     4,     3,     3,     3,     3,     3,
     3,     0,     7,     0,     8,     0,    11,     0,     5,    13,
     3,     1,     1,     5,     5,     7,     1,     1,     0,     6,
     4,     1,     0,     2,     0,     3,     1,     3,     0,     2,
     0,     0,     4,     1,     3,     3,     1,     3,    10,     2,
     3,     0,     1,     1,     3,     1,     1,     3,     7,     0,
     1,     0,     4,     0,     3,     1,     0,     2,     0,     4,
     4,     3,     1,     2,     1,     0,     5,     1,     3,     1,
     3,     0,     3,     1,     1,     6,     6,    10,     0,     3,
     2,     0,     0,     2,     5,     3,     7,     0,     6
};

static const short yydefact[] = {     2,
     0,     0,     0,     0,     0,     0,    39,    39,    16,     0,
    39,     0,     0,     0,     1,     0,     0,     0,     0,     4,
     0,     0,    33,     0,     0,     0,     0,     0,     0,     8,
     9,    10,    11,     0,     0,     0,    32,     0,    62,     0,
    18,     3,     6,     7,    23,    29,     5,    22,    38,    12,
     0,     0,    61,     0,     0,     0,     0,    27,    28,     0,
     0,    35,     0,     0,    14,    33,     0,    57,     0,    19,
    56,     0,     0,    21,     0,    31,     0,    41,     0,     0,
     0,     0,     0,     0,    37,     0,    13,    34,     0,     0,
     0,     0,    58,     0,    55,    24,    25,     0,     0,    30,
    44,     0,    15,    40,    64,    93,     0,     0,    54,    53,
    36,    42,     0,    69,     0,    98,     0,    26,    52,    67,
     0,     0,     0,    94,     0,     0,    43,    47,     0,    66,
     0,     0,     0,     0,    73,    17,    68,    93,     0,     0,
    59,     0,    52,    52,    52,     0,    63,     0,     0,    92,
     0,     0,     0,    96,    50,     0,    45,    48,    46,    51,
    65,    78,    39,     0,    75,    39,     0,    72,    20,     0,
     0,    98,     0,     0,    70,    74,    91,    39,    71,     0,
    98,    95,     0,    76,    90,     0,     0,     0,    82,    97,
    98,     0,     0,     0,     0,    85,    77,    80,     0,    84,
     0,     0,     0,     0,     0,    82,     0,    89,    99,     0,
     0,     0,     0,    79,    81,    83,     0,     0,     0,     0,
    49,     0,     0,     0,     0,    86,    87,     0,     0,     0,
    88,     0,     0
};

static const short yydefgoto[] = {     1,
    15,    34,    62,    78,    24,    56,    47,    48,    60,    38,
    75,    88,    22,    90,   104,   119,   127,   145,   128,   129,
    70,    71,    54,   114,   131,   121,   137,   164,   165,   189,
   197,   198,   199,   200,   167,   115,   116,   124,   125,   172
};

static const short yypact[] = {-32768,
    56,   -15,     2,    23,    28,    61,    51,    51,-32768,    53,
    51,    63,    68,    75,-32768,   110,   111,   113,   114,-32768,
    89,    83,    81,    85,   122,    90,    99,   100,   101,-32768,
-32768,-32768,-32768,     9,    92,    96,    91,   102,   127,    97,
-32768,-32768,-32768,-32768,-32768,     3,    95,-32768,-32768,-32768,
    25,   103,-32768,   104,   105,     4,    98,-32768,-32768,   106,
     9,-32768,   107,   109,-32768,    81,   108,-32768,   112,-32768,
   115,   139,   140,-32768,    11,-32768,   117,-32768,   121,   123,
    -1,     4,   124,    57,-32768,   125,-32768,-32768,   118,    14,
   128,   130,-32768,   119,-32768,-32768,-32768,   147,    49,-32768,
-32768,   131,-32768,-32768,   136,-32768,   116,   126,-32768,-32768,
-32768,-32768,   120,-32768,   143,   129,   142,-32768,    49,   144,
    55,   133,    49,-32768,   132,   134,-32768,     0,   135,-32768,
    10,   138,   141,   145,-32768,-32768,-32768,-32768,   146,   151,
-32768,     1,    49,    49,    49,   153,-32768,   154,    24,   150,
   169,   148,    49,   165,-32768,    49,-32768,-32768,-32768,-32768,
-32768,-32768,    51,    15,-32768,    51,    -5,-32768,-32768,   149,
   152,   129,   155,   156,-32768,-32768,-32768,    51,-32768,    49,
   129,-32768,    49,-32768,-32768,   157,   158,   159,    54,-32768,
   129,    49,   162,   163,   164,-32768,   166,-32768,    -3,-32768,
   168,   170,    49,    49,    49,    54,   160,    80,-32768,    49,
   171,   172,   173,-32768,-32768,-32768,   175,    49,    49,    49,
-32768,   176,   178,   179,    49,-32768,-32768,   180,    49,   182,
-32768,   188,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   137,-32768,   161,
-32768,-32768,    -8,-32768,-32768,-32768,   -64,-32768,-32768,   -98,
   167,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    29,-32768,
-32768,   -12,-32768,   -13,-32768,    59,-32768,    32,  -154,-32768
};


#define	YYLAST		249


static const short yytable[] = {    23,
   111,   155,    26,   -60,    68,    57,    69,   -60,   -60,   -60,
   -60,    45,   -60,   -60,   -60,   -60,   -60,   -60,    85,   142,
    16,   101,   162,   143,   139,    63,   187,    93,   178,    58,
    59,   162,   179,   -60,   -60,   -60,   201,    17,   207,   156,
   144,    94,   208,    86,   -60,    46,   102,   163,    87,   147,
   148,   103,   175,    64,   170,   232,   163,   173,    18,     2,
     3,     4,     5,    19,     6,     7,     8,     9,    10,    11,
   132,   133,   134,   135,   193,   194,   195,   109,   157,   158,
   159,   186,   109,   110,   188,    12,    13,    14,   110,    21,
   196,    25,   136,   202,    97,   -89,    20,    98,    27,   -89,
   193,   194,   195,    28,   211,   212,   213,   196,   109,   196,
    29,   217,    30,    31,   110,    32,    33,    35,    36,   222,
   223,   224,    37,    39,    40,    41,   228,    42,    43,    44,
   230,    49,    50,    51,    53,    61,    55,    52,    72,    65,
    67,    83,    84,    66,    80,    89,    73,   107,    92,   108,
   113,    76,    77,    81,   174,    82,    91,   177,   120,   117,
    99,    96,   100,   118,   105,   106,   112,   122,   138,   185,
   126,   168,   130,   140,   149,   123,   146,   150,   141,   154,
   151,   160,   161,   166,   171,   169,   153,   233,   215,   180,
   181,   184,   176,   214,   216,   183,   152,    74,   191,   192,
   203,   204,   205,   182,   190,     0,   206,   209,     0,     0,
   210,   218,   219,   220,   221,     0,   225,   226,   227,     0,
   229,   231,     0,     0,     0,     0,    79,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    95
};

static const short yycheck[] = {     8,
    99,     1,    11,     0,     1,     3,     3,     4,     5,     6,
     7,     3,     9,    10,    11,    12,    13,    14,     8,    20,
    36,     8,     8,    24,   123,     1,   181,    29,    34,    27,
    28,     8,    38,    30,    31,    32,   191,    36,    42,    39,
    41,    43,    46,    33,    41,    37,    33,    33,    38,    40,
    41,    38,    38,    29,   153,     0,    33,   156,    36,     4,
     5,     6,     7,    36,     9,    10,    11,    12,    13,    14,
    16,    17,    18,    19,    21,    22,    23,    29,   143,   144,
   145,   180,    29,    35,   183,    30,    31,    32,    35,    39,
   189,    39,    38,   192,    38,    42,    36,    41,    36,    46,
    21,    22,    23,    36,   203,   204,   205,   206,    29,   208,
    36,   210,     3,     3,    35,     3,     3,    29,    36,   218,
   219,   220,    42,    39,     3,    36,   225,    29,    29,    29,
   229,    40,    37,    43,     8,    41,    40,    36,    41,    37,
    36,     3,     3,    40,    37,    29,    41,    29,    26,     3,
    15,    45,    44,    42,   163,    41,    36,   166,    39,    44,
    36,    38,    45,    38,    37,    36,    36,    25,    36,   178,
    29,     3,    29,    42,    37,    47,    42,    37,    45,    29,
    36,    29,    29,    34,    20,    38,    41,     0,    29,    41,
    39,    36,   164,   206,   208,    41,   138,    61,    41,    41,
    39,    39,    39,   172,    48,    -1,    41,    40,    -1,    -1,
    41,    41,    41,    41,    40,    -1,    41,    40,    40,    -1,
    41,    40,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "//usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "//usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 91 "parser.y"
{ routine->nbBeats = yyvsp[0].integer; ;
    break;}
case 4:
#line 94 "parser.y"
{if (routine->nbDancers>0) DOERROR("dancers already defined");;
    break;}
case 6:
#line 96 "parser.y"
{ routine->rhythm = yyvsp[0].integer; ;
    break;}
case 7:
#line 98 "parser.y"
{ routine->bpm = yyvsp[0].integer; ;
    break;}
case 8:
#line 100 "parser.y"
{ routine->name = yyvsp[0].string; ;
    break;}
case 9:
#line 102 "parser.y"
{ routine->description = yyvsp[0].string; ;
    break;}
case 10:
#line 104 "parser.y"
{ routine->copyright = yyvsp[0].string; ;
    break;}
case 11:
#line 106 "parser.y"
{ routine->text = yyvsp[0].string; ;
    break;}
case 12:
#line 108 "parser.y"
{for(int j=0; j<6; j++) doublelist[j]=0.0; ;
    break;}
case 13:
#line 109 "parser.y"
{	if (yyvsp[-5].integer >= routine->nbDancers || yyvsp[-5].integer <0) {
						DOERROR("bad dancer index in init");
					}
					for(int j=0; j<6; j++)
						routine->dancerInitPos[yyvsp[-5].integer][j] = doublelist[j];
				;
    break;}
case 14:
#line 116 "parser.y"
{if (parserMode == COMPILE) key = new Key;;
    break;}
case 15:
#line 117 "parser.y"
{	if (parserMode == COMPILE) {
						key->dancer = yyvsp[-6].integer;
						key->start = yyvsp[-5].time.start; key->end = yyvsp[-5].time.end;
						routine->keys->append(key);
						if (yyvsp[-6].integer >= routine->nbDancers || yyvsp[-6].integer <0) {
							DOERROR("bad dancer index in the key");
						}
						if (key->CheckIntegrity() == FALSE) {
							DOERROR("problem in integrity of key");
						}
					}
				;
    break;}
case 16:
#line 130 "parser.y"
{if (parserMode == COMPILE) figure = new Figure();;
    break;}
case 17:
#line 132 "parser.y"
{	if (parserMode == COMPILE) {
						figure->start = yyvsp[-5].time.start; figure->end = yyvsp[-5].time.end; 
						routine->figures->append(figure);
						if (figure->CheckIntegrity() == FALSE) {
							DOERROR("problem in integrity of routine");
						}
					}
				;
    break;}
case 18:
#line 141 "parser.y"
{if (parserMode == COMPILE) notes = new List<Note>;;
    break;}
case 19:
#line 142 "parser.y"
{	if (parserMode == COMPILE) {
						if (yyvsp[-3].integer == -1) {
							yyvsp[-3].integer = MAX_DANCERS;
						} else if (yyvsp[-3].integer >= routine->nbDancers || yyvsp[-3].integer <0) {
							DOERROR("bad dancer index in the key");
						}
						/* notes[i][0] == notes[i][REAL] */
						if (routine->notes[yyvsp[-3].integer][0] != NULL) {
							DOERROR("notes already defined");
							delete notes;
						} else {
							routine->notes[yyvsp[-3].integer][0] = new List<Note>;
							routine->notes[yyvsp[-3].integer][0]->append(notes);
						}
					}
				;
    break;}
case 20:
#line 160 "parser.y"
{	if (parserMode == COMPILE) {
						routine->movies->append(new Movie(yyvsp[-10].string,
								(List<Bezier3D> *) yyvsp[-1].path.path, (List<Bezier3D> *) yyvsp[-4].path.path));
					} else {
						routine->movies->append(new Movie(yyvsp[-10].string, 0, 0));
					}
				;
    break;}
case 21:
#line 173 "parser.y"
{	routine->dancerNames[routine->nbDancers] = yyvsp[0].dancerinfo.name;
					routine->dancerSex[routine->nbDancers] = yyvsp[0].dancerinfo.sex;
					routine->dancerTypes[routine->nbDancers++] = yyvsp[0].dancerinfo.type; ;
    break;}
case 22:
#line 177 "parser.y"
{	routine->dancerNames[routine->nbDancers] = yyvsp[0].dancerinfo.name;
					routine->dancerTypes[routine->nbDancers++] = yyvsp[0].dancerinfo.type; ;
    break;}
case 23:
#line 181 "parser.y"
{ yyval.dancerinfo.name = yyvsp[0].string; yyval.dancerinfo.type = 0; yyval.dancerinfo.sex = MAN; ;
    break;}
case 24:
#line 182 "parser.y"
{ yyval.dancerinfo.name = yyvsp[-3].string; yyval.dancerinfo.type = yyvsp[-1].string; yyval.dancerinfo.sex = MAN; ;
    break;}
case 25:
#line 183 "parser.y"
{ yyval.dancerinfo.name = yyvsp[-1].string; yyval.dancerinfo.type = 0; yyval.dancerinfo.sex = yyvsp[-3].integer; ;
    break;}
case 26:
#line 184 "parser.y"
{ yyval.dancerinfo.name = yyvsp[-3].string; yyval.dancerinfo.type = yyvsp[-1].string; yyval.dancerinfo.sex = yyvsp[-5].integer; ;
    break;}
case 27:
#line 187 "parser.y"
{ yyval.integer = MAN; ;
    break;}
case 28:
#line 188 "parser.y"
{ yyval.integer = WOMAN; ;
    break;}
case 29:
#line 189 "parser.y"
{ DOERROR("bad sex for dancer"); ;
    break;}
case 30:
#line 195 "parser.y"
{ yyval.time.start = yyvsp[-3].integer; yyval.time.end = yyvsp[-1].integer; ;
    break;}
case 31:
#line 197 "parser.y"
{ DOERROR("bad time range");
											  yyval.time.start = -1; yyval.time.end = -1; ;
    break;}
case 32:
#line 199 "parser.y"
{ DOERROR("need a time range");
											  yyval.time.start = -1; yyval.time.end = -1; ;
    break;}
case 33:
#line 201 "parser.y"
{ DOERROR("need time range for the key"); ;
    break;}
case 36:
#line 211 "parser.y"
{	switch (yyvsp[-2].integer) {
						case cogX:
						case cogY:
						case cogZ:
						case cogRX:
						case cogRY:
						case cogRZ:	doublelist[yyvsp[-2].integer-cogX] = yyvsp[0].numeric;
									break;

						default:	DOERROR("bad init track");
					}
				;
    break;}
case 37:
#line 223 "parser.y"
{	DOERROR("bad track name for key"); YYABORT; ;
    break;}
case 38:
#line 228 "parser.y"
{ yyval.integer = yyvsp[-1].integer; ;
    break;}
case 39:
#line 229 "parser.y"
{ yyval.integer = 0; DOERROR("need dancer"); ;
    break;}
case 42:
#line 236 "parser.y"
{if (parserMode == COMPILE) chunks = new List<Chunk>;;
    break;}
case 43:
#line 237 "parser.y"
{	if (parserMode == COMPILE) {
						if (key->part[yyvsp[-3].integer] != NULL) {
							DOERROR("track already defined");
							delete chunks;
						} else {
							if (chunks->head() == NULL) {
								chunks->append(new Chunk(yyvsp[0].point.time,routine->nbBeats,
										yyvsp[0].point.value,yyvsp[0].point.value, yyvsp[0].point.value,yyvsp[0].point.value, -1,-1, TRUE));
							}
							key->part[yyvsp[-3].integer] = chunks; 
						}
					}
				;
    break;}
case 44:
#line 250 "parser.y"
{	DOERROR("bad track name for key"); YYABORT; ;
    break;}
case 45:
#line 254 "parser.y"
{
					yyval.point = yyvsp[-2].point;
					v1 = yyvsp[-2].point.value;
					v2 = yyvsp[0].point.value;
					if (parserMode == COMPILE) {
						chunks->prepend(new Chunk(yyvsp[-2].point.time,yyvsp[0].point.time, v1,v2,
										v1+(v2-v1)/3,v1+(v2-v1)*2/3, -1,-1));
					}
				;
    break;}
case 46:
#line 263 "parser.y"
{
					yyval.point = yyvsp[-2].point;
					if (parserMode == COMPILE) {
						chunks->prepend(new Chunk(yyvsp[-2].point.time,yyvsp[0].point.time, yyvsp[-2].point.value,yyvsp[0].point.value,
												   yyvsp[-1].doublelist.v[0],yyvsp[-1].doublelist.v[1],(int) yyvsp[-1].doublelist.v[2], (int) yyvsp[-1].doublelist.v[3]));
					}
				;
    break;}
case 47:
#line 270 "parser.y"
{ yyval.point = yyvsp[0].point; ;
    break;}
case 48:
#line 271 "parser.y"
{ yyval.point = yyvsp[-2].point; ;
    break;}
case 49:
#line 275 "parser.y"
{ yyval.doublelist.v = doublelist;
						  yyval.doublelist.v[0]=yyvsp[-7].numeric; yyval.doublelist.v[1]=yyvsp[-5].numeric; yyval.doublelist.v[2]=yyvsp[-3].numeric; yyval.doublelist.v[3]=yyvsp[-1].numeric; ;
    break;}
case 50:
#line 277 "parser.y"
{ DOERROR("bad bezier parameters"); ;
    break;}
case 51:
#line 280 "parser.y"
{ yyval.point.time = yyvsp[0].integer; yyval.point.value = yyvsp[-2].numeric; ;
    break;}
case 52:
#line 281 "parser.y"
{ DOERROR("need a point (value@time)"); ;
    break;}
case 53:
#line 284 "parser.y"
{ yyval.numeric = yyvsp[0].numeric; ;
    break;}
case 54:
#line 285 "parser.y"
{ yyval.numeric = yyvsp[0].integer; ;
    break;}
case 55:
#line 290 "parser.y"
{
					yyval.annotation = yyvsp[-2].annotation;
					if (yyvsp[-2].annotation.end < yyvsp[-2].annotation.start ||
						yyvsp[-2].annotation.start < 0 || yyvsp[-2].annotation.start > routine->nbBeats ||
						yyvsp[-2].annotation.end < 0 || yyvsp[-2].annotation.end > routine->nbBeats) {
						DOERROR("bad time range for note : exceeds routine or end<start.");
					} else if (parserMode == COMPILE) {
						notes->prepend(new Note(yyvsp[-2].annotation.start, yyvsp[-2].annotation.end, yyvsp[-2].annotation.string));
					}
				;
    break;}
case 56:
#line 300 "parser.y"
{
					yyval.annotation = yyvsp[0].annotation;
					if (yyvsp[0].annotation.end < yyvsp[0].annotation.start ||
						yyvsp[0].annotation.start < 0 || yyvsp[0].annotation.start > routine->nbBeats ||
						yyvsp[0].annotation.end < 0 || yyvsp[0].annotation.end > routine->nbBeats) {
						DOERROR("bat time range for note : exceeds routine or end<start.");
					} else if (parserMode == COMPILE) {
						notes->prepend(new Note(yyvsp[0].annotation.start, yyvsp[0].annotation.end, yyvsp[0].annotation.string));
					}
				;
    break;}
case 57:
#line 310 "parser.y"
{ DOERROR("bad time range for note"); ;
    break;}
case 58:
#line 314 "parser.y"
{	yyval.annotation.start = yyval.annotation.end = yyvsp[0].integer;
					if (parserMode == COMPILE) {
						yyval.annotation.string = yyvsp[-2].string;
					} else {
						delete[] yyvsp[-2].string;
					}
				;
    break;}
case 59:
#line 322 "parser.y"
{	yyval.annotation.start = yyvsp[-3].integer;
					yyval.annotation.end = yyvsp[-1].integer;
					if (parserMode == COMPILE) {
						yyval.annotation.string = yyvsp[-6].string;
					} else {
						delete[] yyvsp[-6].string;
					}
				;
    break;}
case 60:
#line 330 "parser.y"
{ DOERROR("need a note (string@time or string@[time:time])"); ;
    break;}
case 61:
#line 336 "parser.y"
{	if (parserMode == COMPILE) {
						figure->filename = yyvsp[0].string;
					} else
						delete yyvsp[0].string;
				;
    break;}
case 62:
#line 341 "parser.y"
{ DOERROR("need a name for the routine"); ;
    break;}
case 64:
#line 344 "parser.y"
{ DOERROR("need a map statement in the routine"); ;
    break;}
case 65:
#line 347 "parser.y"
{ if (parserMode == COMPILE) {
												if (figure->nbMap<MAX_DANCERS)
													figure->map[figure->nbMap++]=yyvsp[0].integer;
												  if (yyvsp[0].integer >= routine->nbDancers || yyvsp[0].integer <-1)
													DOERROR("bad dancer index in map");
											  }
											;
    break;}
case 66:
#line 354 "parser.y"
{ if (parserMode == COMPILE) {
												figure->map[figure->nbMap++]=yyvsp[0].integer; 
												  if (yyvsp[0].integer >= routine->nbDancers || yyvsp[0].integer <-1)
													DOERROR("bad dancer index in map");
											  }
											;
    break;}
case 67:
#line 360 "parser.y"
{ DOERROR("bad dancer index in map"); ;
    break;}
case 72:
#line 369 "parser.y"
{	if (parserMode == COMPILE) {
											if (figure->color != NULL) {
												DOERROR("bad dancer index for the modification");
												delete[] yyvsp[0].string;
											} else {
												figure->color = yyvsp[0].string;
											}
										} else {
											delete[] yyvsp[0].string;
										}
									;
    break;}
case 73:
#line 380 "parser.y"
{  if (parserMode == COMPILE) figure->includeNotes = 1; ;
    break;}
case 76:
#line 388 "parser.y"
{if (parserMode == COMPILE) modifs = new List<Modif>;;
    break;}
case 77:
#line 389 "parser.y"
{	if (parserMode == COMPILE) {
						if (yyvsp[-3].integer >= routine->nbDancers || yyvsp[-3].integer <-1) {
							DOERROR("bad dancer index for the modification");
							delete modifs;
						} else if (figure->modifications[yyvsp[-3].integer][yyvsp[-4].integer] != NULL) {
							DOERROR("modification already defined for this track");
							delete modifs;
						} else
							figure->modifications[yyvsp[-3].integer][yyvsp[-4].integer] = modifs; 
					}
				;
    break;}
case 78:
#line 400 "parser.y"
{ DOERROR("bad track name for modification"); ;
    break;}
case 79:
#line 403 "parser.y"
{ modif.type = 0; ;
    break;}
case 80:
#line 404 "parser.y"
{ modif.type = 0; ;
    break;}
case 81:
#line 408 "parser.y"
{	if (parserMode == COMPILE) {
						modif.time = yyvsp[0].integer;
						modifs->append(new Modif(&modif));
					}
				;
    break;}
case 82:
#line 413 "parser.y"
{ DOERROR("need a action list (list@time)"); ;
    break;}
case 85:
#line 421 "parser.y"
{	modif.type |= VAL_VALUE;
					modif.data.value = yyvsp[0].numeric;
				;
    break;}
case 86:
#line 425 "parser.y"
{	modif.type |= VAL_LEFT;
					modif.data.leftValue = yyvsp[-3].numeric;
					modif.data.leftTime = (int) yyvsp[-1].numeric;
				;
    break;}
case 87:
#line 430 "parser.y"
{	modif.type |= VAL_RIGHT;
					modif.data.rightValue = yyvsp[-3].numeric;
					modif.data.rightTime = (int) yyvsp[-1].numeric;
				;
    break;}
case 88:
#line 435 "parser.y"
{	modif.type |= VAL_LEFT;
					modif.type |= VAL_RIGHT;
					modif.data.leftValue = yyvsp[-7].numeric;
					modif.data.leftTime = (int) yyvsp[-5].numeric;
					modif.data.rightValue = yyvsp[-3].numeric;
					modif.data.rightTime = (int) yyvsp[-1].numeric;
				;
    break;}
case 89:
#line 442 "parser.y"
{ DOERROR("need a action"); ;
    break;}
case 90:
#line 448 "parser.y"
{	if (yyvsp[0].integer >= routine->nbDancers || yyvsp[0].integer <0) {
						DOERROR("bad dancer index for the reject statement")
					} else if (parserMode == COMPILE) {
						extern int jointToTrack[][4];
						for(int j=0; j<4 && jointToTrack[yyvsp[-1].integer][j]!=-1; j++)
							figure->flags[yyvsp[0].integer][jointToTrack[yyvsp[-1].integer][j]] |= REJECT;
					}
				;
    break;}
case 91:
#line 457 "parser.y"
{	if (yyvsp[0].integer >= routine->nbDancers || yyvsp[0].integer <0) {
						DOERROR("bad dancer index for the reject statement")
					} else if (parserMode == COMPILE) {
						extern int jointToTrack[][4];
						for(int j=0; j<4 && jointToTrack[yyvsp[0].integer][j]!=-1; j++)
							figure->flags[yyvsp[0].integer][jointToTrack[yyvsp[-1].integer][j]] |= REJECT;
					}
				;
    break;}
case 92:
#line 465 "parser.y"
{ DOERROR("bad track name in 'reject'"); ;
    break;}
case 93:
#line 469 "parser.y"
{if (parserMode == COMPILE) path = new List<Bezier3D>;;
    break;}
case 94:
#line 470 "parser.y"
{
					if (parserMode == COMPILE) {
						if (path->head() == NULL) {
							DOERROR("bad path : must contain at least two points");
							delete path;
							path = 0;
						}
						yyval.path.path = path;
					}
				;
    break;}
case 95:
#line 483 "parser.y"
{	yyval.point3D = yyvsp[-4].point3D;
					yyval.point3D.time = yyvsp[-2].integer;
					if (parserMode == COMPILE) {
						class Bezier3D *b = new Bezier3D(yyvsp[-2].integer, yyvsp[0].point3D.time);
						b->startX = yyvsp[-4].point3D.x; b->startY = yyvsp[-4].point3D.y; b->startZ = yyvsp[-4].point3D.z;
						b->leftX = yyvsp[-1].doublelist.v[0]; b->leftY = yyvsp[-1].doublelist.v[1]; b->leftZ = yyvsp[-1].doublelist.v[2];
						b->rightX = yyvsp[-1].doublelist.v[3]; b->rightY = yyvsp[-1].doublelist.v[4]; b->rightZ = yyvsp[-1].doublelist.v[5];
						b->endX = yyvsp[0].point3D.x; b->endY = yyvsp[0].point3D.y; b->endZ = yyvsp[0].point3D.z;
						delete[] yyvsp[-1].doublelist.v;
						path->prepend(b);
					}
				;
    break;}
case 96:
#line 496 "parser.y"
{	yyval.point3D = yyvsp[-2].point3D;
					yyval.point3D.time = yyvsp[0].integer;
				;
    break;}
case 97:
#line 501 "parser.y"
{ yyval.point3D.x = yyvsp[-5].numeric; yyval.point3D.y = yyvsp[-3].numeric; yyval.point3D.z = yyvsp[-1].numeric; ;
    break;}
case 98:
#line 502 "parser.y"
{ DOERROR("need a point3D (<x,y,z>)"); ;
    break;}
case 99:
#line 505 "parser.y"
{	yyval.doublelist.v = new double[6];
					yyval.doublelist.v[0]=yyvsp[-3].point3D.x; yyval.doublelist.v[1]=yyvsp[-3].point3D.y; yyval.doublelist.v[2]=yyvsp[-3].point3D.z;
					yyval.doublelist.v[3]=yyvsp[-1].point3D.x; yyval.doublelist.v[4]=yyvsp[-1].point3D.y; yyval.doublelist.v[5]=yyvsp[-1].point3D.z;
				;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "//usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 511 "parser.y"
 //=============================================================================================


void yyerror(const char *msg)
{
static char error[100];
extern struct Tcl_Interp *currentInterp;

	sprintf(error, "ERROR: line %d = %s", yylineno, msg);
	Tcl_AppendResult(currentInterp, error, NULL);
}
